#!/usr/bin/python 
#-*- coding:Utf-8 -*-
#
# xenmonitor.py
# v 1.0 - Nicolas AGIUS - 10/2010
# Usage: nohup /usr/local/sbin/xenmonitor.py >/dev/null 2>/dev/null &
#
###################################################################################
## Daemon pour le monitoring RRD des VM
#
# Copyright (C) 2010 Nicolas AGIUS <nicolas_agius@yahoo.fr>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
###################################################################################

import SocketServer, platform
import cxm.node, cxm.core

# Configure cxm module
cxm.core.cfg['DEBUG']=False
cxm.core.cfg['QUIET']=True

# Globals vars
node=None

class MyTCPHandler(SocketServer.BaseRequestHandler):
	"""
	The RequestHandler class for our server.

	It is instantiated once per connection to the server, and must
	override the handle() method to implement communication to the
	client.
	"""

	def handle(self):
		# self.request is the TCP socket connected to the client
		#        self.data = self.request.recv(1024).strip()
		#        print "%s wrote:" % self.client_address[0]

		global node
		repr=""

		# CPU usage
		cpus=node.metrics.get_vms_cpu_usage()
		for vm in cpus.keys():
			repr += "CPU_" + vm.replace('-','_') +"="+ "%.1f" % round(cpus[vm]) + "\n"

		# RAM usage
		for vm in node.get_vms():
			repr += "RAM_" + vm.name.replace('-','_') +"="+ str(vm.get_ram()) + "\n"

		repr += "RAM_Domain_0=" + str(int(node.run("cat /proc/meminfo | grep MemTotal | awk '{print $2;}'").read())/1024) + "\n"

		self.request.send(repr)

if __name__ == "__main__":
	HOST, PORT = "0.0.0.0", 9999

	# Initiate cxm API
	node=cxm.node.Node(platform.node())
	node.metrics.init_cache()

	# Create the server, binding to localhost on port 9999
	server = SocketServer.TCPServer((HOST, PORT), MyTCPHandler)

	# Activate the server; this will keep running until you
	# interrupt the program with Ctrl-C
	server.serve_forever()

# EOF
